Leetcode 11. Container With Most Water [medium] [java]

Given n non-negative integers a1, a2, …, an , where each represents a point at coordinate (i, ai). n vertical lines are drawn such that the two endpoints of line i is at (i, ai) and (i, 0). Find two lines, which together with x-axis forms a container, such that the container contains the most water.

Note: You may not slant the container and n is at least 2.

Example
在这里插入图片描述

Solution 1: brute force
Time Complexity: O(n^2), Space Complexity: O(1)

class Solution {
    public int maxArea(int[] height) {
        int area = 0;
        for(int i = 0; i < height.length; i++) 
            for(int j = i+1; j < height.length;j++) {
                int temp = (j-i)*Math.min(height[i],height[j]);
                if(area < temp)
                    area = temp;
            }
        return area;
    }
}

==Solution 2: ==
Time Complexity: O(n), Space Complexity: O(1)
Consideration:

  1. we use two pointers to start from the left end and right end of height, since at the beginning, their difference is the biggest
  2. In each iteration, we calculate the area between the two pointers and compare it with the max. Afterward, we change the pointer which has a shorter height.
class Solution {
    public int maxArea(int[] height) {
        int max = 0;
        int left = 0;
        int right = height.length-1;
        while(left < right) {
            max = Math.max(max,  (right-left)*Math.min(height[left],height[right]));
            if(height[left] < height[right])
                left++;
            else
                right--;
        }

        return max;
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值